#### Description:

This function creates a new GrismMap and optionally initialises its attributes.

A GrismMap is a specialised form of Mapping which transforms 1-dimensional coordinates using the spectral dispersion equation described in FITS-WCS paper III `"` Representation of spectral coordinates in FITS`"` . This describes the dispersion produced by gratings, prisms and grisms.

When initially created, the forward transformation of a GrismMap transforms input `"` grism parameter`"` values into output wavelength values. The `"` grism parameter`"` is a dimensionless value which is linearly related to position on the detector. It is defined in FITS-WCS paper III as `"` the offset on the detector from the point of intersection of the camera axis, measured in units of the effective local length`"` . The units in which wavelength values are expected or returned is determined by the values supplied for the GrismWaveR, GrismNRP and GrismG attribute: whatever units are used for these attributes will also be used for the wavelength values.

#### Synopsis

AstGrismMap ∗astGrismMap( const char ∗options, ... )

#### Parameters:

##### options

Pointer to a null-terminated string containing an optional comma-separated list of attribute assignments to be used for initialising the new GrismMap. The syntax used is identical to that for the astSet function and may include `"` printf`"` format specifiers identified by `"` %`"` symbols in the normal way.

##### ...

If the `"` options`"` string contains `"` %`"` format specifiers, then an optional list of additional arguments may follow it in order to supply values to be substituted for these specifiers. The rules for supplying these are identical to those for the astSet function (and for the C `"` printf`"` function).

#### Returned Value

##### astGrismMap()

A pointer to the new GrismMap.

#### Notes:

- A null Object pointer (AST__NULL) will be returned if this function is invoked with the AST error status set, or if it should fail for any reason.

Copyright (C) 2021 East Asian Observatory